'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

exports.removeFlowComment = removeFlowComment;
exports.addFlowComment = addFlowComment;
// @flow
/* ::
type Comment = {
  [key: string]: any,
  value: string,
  ignore: boolean,
}

type Comments = Array<Comment>
*/

var FLOW_DIRECTIVE = '@flow';

function removeFlowComment(comments /* : Comments */) {
  if (!Array.isArray(comments)) {
    throw new TypeError('Expected a Array<Comment>, got ' + (typeof comments === 'undefined' ? 'undefined' : _typeof(comments)));
  }

  var _iteratorNormalCompletion = true;
  var _didIteratorError = false;
  var _iteratorError = undefined;

  try {
    for (var _iterator = comments[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
      var comment = _step.value;

      if (comment.value.indexOf(FLOW_DIRECTIVE) >= 0) {
        comment.value = comment.value.replace(FLOW_DIRECTIVE, '');
        if (!comment.value.replace(/\*/g, '').trim()) {
          comment.ignore = true;
        }
      }
    }
  } catch (err) {
    _didIteratorError = true;
    _iteratorError = err;
  } finally {
    try {
      if (!_iteratorNormalCompletion && _iterator.return) {
        _iterator.return();
      }
    } finally {
      if (_didIteratorError) {
        throw _iteratorError;
      }
    }
  }
}

// line ? /* @flow */ or // @flow
function addFlowComment(path /* : Object */) {
  path.addComment('leading', ' ' + FLOW_DIRECTIVE, true);
}